(* Release 3.10 *)(* For CW5 *)
(*-------------------------------------------------------------------------*
*                                                                          *
*  FIO.MOD - File input/output                                             *
*                                                                          *
*  COPYRIGHT (C) 1987..1992 Clarion Software Corporation.                  *
*  All Rights Reserved                                                     *
*                                                                          *
*  Modified for Topspeed Clarion V5.0    CWS    09-07-99                   *
*               Carl W. Sumner   cwsumner@compuserve.com                   *
*  Add calls to set ThreadOk in GetPos.  CWS    07-06-01                   *
*               Carl W. Sumner   cwsumner@compuserve.com                   *
*  Change 'LONGCARD(Var)' to the form 'VAL(LONCARD, Var)'.  CWS  08-17-01  *
*  Change 'REAL(Var)' to the form 'VAL(REAL, Var)'.         CWS  08-17-01  *
*               Carl W. Sumner   cwsumner@compuserve.com                   *
*  Change 32 Bit Handle I/O back to use filenumber calls.   CWS  08-22-01  *
*  Change _lopen() and _lcreat() calls to use FileOpen().   CWS  08-23-01  *
*               Carl W. Sumner   cwsumner@compuserve.com                   *
*                                                                          *
*--------------------------------------------------------------------------*)
(* Uses some procedures from WFIO.MOD/DEF by James K Smith *)
(* Minimal win/NT FIO replacement. Does NOT deal with overlapped files. *)
(* James K Smith III (72642,3276, james@tapscan.com), 3 Oct 96 *)

(*# call(o_a_copy => off) *)
(* !!!# check(stack=>off,index=>off,range=>off,overflow=>off,nil_ptr=>off) *)

IMPLEMENTATION MODULE FIO;

IMPORT Lib, Str, CWRUN;

FROM Windows IMPORT
  DWORD,LPDWORD,LPVOID,LPSTR,NULL,BOOL,READ_WRITE,READ,
  INVALID_HANDLE_VALUE,
  OFSTRUCT,OF_READ,OF_WRITE,OF_READWRITE,OF_CREATE,OF_EXIST,      (* 08-23-01 *)
 (*  T__32BIT__ ----
  CreateFileA,CloseHandle,ReadFile,WriteFile,SetFilePointer,
  LPSECURITY_ATTRIBUTES,LPCVOID,LPOVERLAPPED,PLONG;
 ------*)
 (*  F__32BIT__ *)
  OpenFile,_llseek,_lread,_lwrite,_lclose;     (* 08-23-01 *)
 (*   E*)


CONST
  TrueStr   = 'TRUE';
  FalseStr  = 'FALSE';
  MaxProcess = 64;

VAR
  IOR: ARRAY [1..MaxProcess] OF SIGNED;   (* To allow threads *)
  OKTable:  ARRAY [1..MaxProcess] OF BOOLEAN;
  EOFTable: ARRAY [1..MaxProcess] OF BOOLEAN;
  OF_STRUCT: OFSTRUCT;                           (* 08-23-01 *)

TYPE
  Str80 = ARRAY[0..79] OF CHAR;


CONST
  GENERIC_READ                    = 80000000H;
  GENERIC_WRITE                   = 40000000H;
  GENERIC_ALL                     = 10000000H;
  SECTION_EXTEND_SIZE             = 0010H;
  SECTION_MAP_EXECUTE             = 0008H;
  SECTION_MAP_READ                = 0004H;
  SECTION_MAP_WRITE               = 0002H;
  SECTION_QUERY                   = 0001H;
  FILE_SHARE_READ                 = 00000001H;
  FILE_SHARE_WRITE                = 00000002H;
  FILE_FLAG_BACKUP_SEMANTICS      = 02000000H;
  FILE_FLAG_DELETE_ON_CLOSE       = 04000000H;
  FILE_FLAG_NO_BUFFERING          = 20000000H;
  FILE_FLAG_OVERLAPPED            = 40000000H;
  FILE_FLAG_POSIX_SEMANTICS       = 01000000H;
  FILE_FLAG_RANDOM_ACCESS         = 10000000H;
  FILE_FLAG_SEQUENTIAL_SCAN       = 08000000H;
  FILE_FLAG_WRITE_THROUGH         = 80000000H;
  FILE_MAP_COPY                   = SECTION_QUERY;
  FILE_MAP_READ                   = SECTION_MAP_READ;
  FILE_MAP_WRITE                  = SECTION_MAP_WRITE;
  FILE_ATTRIBUTE_ARCHIVE          = 00000020H;
  FILE_ATTRIBUTE_ATOMIC_WRITE     = 00000200H;
  FILE_ATTRIBUTE_COMPRESSED       = 00000800H;
  FILE_ATTRIBUTE_DIRECTORY        = 00000010H;
  FILE_ATTRIBUTE_HIDDEN           = 00000002H;
  FILE_ATTRIBUTE_NORMAL           = 00000080H;
  FILE_ATTRIBUTE_READONLY         = 00000001H;
  FILE_ATTRIBUTE_SYSTEM           = 00000004H;
  FILE_ATTRIBUTE_TEMPORARY        = 00000100H;
  FILE_ATTRIBUTE_XACTION_WRITE    = 00000400H;
  FILE_BEGIN                      = 0;
  FILE_CURRENT                    = 1;
  FILE_END                        = 2;
  CREATE_NEW                      = 1;
  CREATE_ALWAYS                   = 2;
  OPEN_EXISTING                   = 3;
  OPEN_ALWAYS                     = 4;
  TRUNCATE_EXISTING               = 5;
  SECURITY_ANONYMOUS_LOGON_RID    = 00000007H;
  SECURITY_BATCH_RID              = 00000003H;
  SECURITY_BUILTIN_DOMAIN_RID     = 00000020H;
  SECURITY_EFFECTIVE_ONLY         = 00080000H;
  SECURITY_CONTEXT_TRACKING       = 00040000H;
  Normal                          = 0;
  Read_Only                       = 1;
  Hidden                          = 2;
  System                          = 3;




PROCEDURE SetIOR(Num: SIGNED);
BEGIN
  IOR[VAL(CARDINAL, CWRUN.THREAD())] := Num;       (* 08-17-01 *)
END SetIOR;


PROCEDURE SetThreadOK( b : BOOLEAN);
BEGIN
  OK := b;
  OKTable[VAL(CARDINAL, CWRUN.THREAD())] := b;     (* 08-17-01 *)
END SetThreadOK;


PROCEDURE SetThreadEOF( b : BOOLEAN);
BEGIN
  EOF := b;
  EOFTable[VAL(CARDINAL, CWRUN.THREAD())] := b;    (* 08-17-01 *)
END SetThreadEOF;


PROCEDURE ErrorCheck(Code: CARDINAL; ErrNum: CARDINAL; Msg, Name: ARRAY OF CHAR);
VAR
    ErrMsg: ARRAY [0..119] OF CHAR;
    NumStr: ARRAY [0..19] OF CHAR;
    ok: BOOLEAN;
BEGIN
    IF ErrNum = 0 THEN
      ErrNum := Lib.SysErrno();
    END;
    IF IOcheck THEN
        Str.Copy(ErrMsg, Msg);
        Str.Append(ErrMsg, Name);
        Str.Append(ErrMsg, '. OS Error Code ');
        Str.CardToStr(VAL(LONGCARD, ErrNum), NumStr, 10, ok);  (* 08-17-01 *)
        Str.Append(ErrMsg, NumStr);
        Lib.RunTimeError(00, Code+0A0H, ErrMsg);
    END;
    SetIOR(ErrNum);
END ErrorCheck;



PROCEDURE IOresult () : CARDINAL;
BEGIN
  RETURN CARDINAL( IOR[VAL(CARDINAL, CWRUN.THREAD())] );  (* 08-17-01 *)
END IOresult;



PROCEDURE WrBin(F:File;Buf:ARRAY OF BYTE;Count:CARDINAL);
VAR
 (*  F__32BIT__ *)
  amt       : SIGNED;
 (*   E*)
 (*  T__32BIT__ ----
  ok        : BOOL;
  amtwritten: LPDWORD;
 ------*)
  IOx: SIGNED;
BEGIN
  SetIOR(0);
  SetThreadOK(TRUE);
 (*  T__32BIT__ ----
  ok := WriteFile(F,LPCVOID(ADR(Buf)),DWORD(Count),amtwritten,LPOVERLAPPED(NULL));
  IF NOT BOOLEAN(ok) THEN IOx := -1 ELSE IOx := 0 END;
 ------*)
 (*  F__32BIT__ *)
  amt:= _lwrite(F,Buf,Count);
  IF amt = -1 THEN IOx := -1 ELSE IOx := 0 END;
 (*   E*)
  SetIOR(IOx);
  IF IOx # 0 THEN
    ErrorCheck(6, 0, 'WrBin : ', Lib.NilStr);
    SetThreadOK(FALSE);
  END;
END WrBin;


PROCEDURE Flush(F: File);
VAR
 (*  T__32BIT__ ----
  ret: BOOL;
 ------*)
 (*  F__32BIT__ *)
 (*   E*)
  IOx: SIGNED;
BEGIN
 (*  T__32BIT__ ----
  (*ret := FlushFileBuffers( F );*)
  ret := 0;            (* ********* Patch *)
  IF ret # 0 THEN IOx := -1 ELSE IOx := 0 END;
 ------*)
 (*  F__32BIT__ *)
  (* No flush implemented *)
  IOx := 0;
 (*   E*)
  SetIOR(IOx);
END Flush;


PROCEDURE Truncate(F: File);

BEGIN
  Lib.RunTimeError(00, 0A0H, "Truncate Not Implemented");
  SetIOR(0);
  Flush( F );
  IF FALSE THEN
    ErrorCheck(0CH, 0, 'Truncate : ', Lib.NilStr);
  END;
END Truncate;



PROCEDURE RdBin(F: File; VAR Buf: ARRAY OF BYTE; Count: CARDINAL) : CARDINAL;
VAR
 (*  F__32BIT__ *)
  amt    : SIGNED;
 (*   E*)
 (*  T__32BIT__ ----
  rok    : BOOL;
  amtread: LPDWORD;
 ------*)
  IOx: SIGNED;
BEGIN
  SetIOR(0);                                     (* 07-06-01 *)
  SetThreadOK(TRUE);
  SetThreadEOF(FALSE);
 (*  T__32BIT__ ----
  rok := ReadFile(F,LPCVOID(ADR(Buf)),DWORD(Count),amtread,LPOVERLAPPED(NULL));
  IF NOT BOOLEAN(rok) THEN IOx := -1 ELSE IOx := 0 END;
  SetIOR(IOx);
  IF CARDINAL(amtread^) # Count THEN
 ------*)
 (*  F__32BIT__ *)
  amt := _lread(F,Buf,Count);
  IF amt = -1 THEN IOx := -1 ELSE IOx := 0 END;
  SetIOR(IOx);
  IF amt # SIGNED(Count) THEN
 (*   E*)
    SetThreadOK(FALSE);
    SetThreadEOF(TRUE);
    IF IOx # 0 THEN
      ErrorCheck(7, 0, 'RbBin : ', Lib.NilStr);
    END;
  END;
 (*  T__32BIT__ ----
  RETURN UNSIGNED(amtread^);
 ------*)
 (*  F__32BIT__ *)
  RETURN amt;
 (*   E*)
END RdBin;


PROCEDURE WrStr(F: File; Buf: ARRAY OF CHAR);
BEGIN
  WrBin( F,Buf,Str.Length( Buf ) );
END WrStr;


PROCEDURE WrLn(F: File);
TYPE a = ARRAY [ 0..1 ] OF CHAR;
BEGIN
  WrBin( F, a( CHR( 13 ),CHR( 10 ) ), 2 )
END WrLn;


PROCEDURE RdChar(F: File ) : CHAR;
VAR c : ARRAY[0..1] OF CHAR;  Ret : CARDINAL;
BEGIN
  SetIOR(0);
  SetThreadOK(TRUE);                            (* 07-06-01 *)
  Ret := RdBin(F, c, 1);
  IF c[0] = CHR(26) THEN
    SetThreadEOF(TRUE);
  END;
  RETURN c[0];
END RdChar;


PROCEDURE RdStr(F: File; VAR Buf: ARRAY OF CHAR);
VAR
  i,h : CARDINAL;
  c   : CHAR;
BEGIN
  i  := 0;
  h  := HIGH( Buf );
  SetThreadOK(TRUE);
  LOOP
     IF i > h THEN RETURN END;
     c := RdChar( F );
     IF EOF OR (c = CHR( 26 )) THEN
       Buf[ i ] := CHR(0);
       SetThreadEOF( (i = 0) );
       RETURN;
     ELSIF c = EOL THEN
       Buf[ i ] := CHR(0);
       RETURN;
     ELSIF (c # CHR( 10 )) AND (c # CHR( 13 )) THEN
       Buf[ i ] := c;
       INC( i );
     END;
  END;
END RdStr;


PROCEDURE RdItem( F : File; VAR S : ARRAY OF CHAR );
VAR c : CHAR; i,L : CARDINAL;
BEGIN
  i := 0;
  LOOP
    c := RdChar( F );
    IF NOT ThreadOK() OR NOT (c IN Separators) THEN EXIT; END;
  END;
  L := HIGH( S );
  LOOP
    IF NOT ThreadOK() OR ( c IN Separators ) THEN EXIT; END;
    S[i] := c;
    INC( i );
    IF i > L THEN
      EXIT;
    ELSE
      c := RdChar( F );
      IF c = CHR(26) THEN
        SetThreadOK(TRUE);
        EXIT;
      ELSIF c = CHR(13) THEN
        c := RdChar(F);
        EXIT;
      END;
    END;
  END;
  IF i <= L THEN S[i] := 0C; END;
END RdItem;


(*# save,
    call(o_a_copy => on) *)

PROCEDURE WrStrAdj(F: File; S: ARRAY OF CHAR; Length: INTEGER);
VAR
  L : CARDINAL;
  a : INTEGER;
BEGIN
  SetThreadOK(TRUE);
  L  := Str.Length( S );
  a  := ABS( Length ) - INTEGER( L );
  IF (a < 0) AND ChopOff THEN
    L := CARDINAL(ABS(Length));
    IF L>HIGH(S) THEN
      L := HIGH(S)+1;
    ELSE
      S[L] := CHR(0);
    END;
    WHILE (L>0) DO DEC(L) ; S[L] := '?'; END;
    SetThreadOK(FALSE);
    a  := 0;
  END;
  IF (Length > 0) AND (a > 0) THEN WrCharRep( F, PrefixChar, a ); END;
  WrStr( F,S );
  IF (Length < 0) AND (a > 0) THEN WrCharRep( F, SuffixChar, a ); END;
END WrStrAdj;

(*# restore *)


PROCEDURE WrChar(F: File; V: CHAR);
BEGIN
  WrBin( F, V, 1 );
END WrChar;


PROCEDURE WrCharRep(F: File; V: CHAR ; Count: CARDINAL);
VAR
  S   : Str80;
  i,j : CARDINAL;
BEGIN
  WHILE Count>0 DO
    i := SIZE(S);
    IF i > Count THEN i := Count END;
    DEC(Count,i);
    FOR j := 0 TO i-1 DO S[j] := V END;
    WrBin( F,S,i );
    IF NOT ThreadOK() THEN RETURN END;
  END;
END WrCharRep;


PROCEDURE WrBool(F: File; V: BOOLEAN; Length: INTEGER);
BEGIN
  IF V THEN
    WrStrAdj( F,TrueStr,Length );
  ELSE
    WrStrAdj( F,FalseStr,Length );
  END;
END WrBool;


PROCEDURE WrShtInt(F: File; V: SHORTINT; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.IntToStr( LONGINT(V),S,10,b);
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrShtInt;


PROCEDURE WrInt(F: File; V: INTEGER; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.IntToStr( LONGINT(V),S,10,b);
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrInt;


PROCEDURE WrLngInt(F: File; V: LONGINT; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.IntToStr( V,S,10,b);
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrLngInt;


PROCEDURE WrShtCard(F: File; V: SHORTCARD; Length: INTEGER);
VAR S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(VAL(LONGCARD, V),S,10,b);     (* 08-17-01 *)
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrShtCard;


PROCEDURE WrCard(F: File; V: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(VAL(LONGCARD, V),S,10,b);     (* 08-17-01 *)
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrCard;


PROCEDURE WrLngCard(F: File; V: LONGCARD; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(V,S,10,b);
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrLngCard;


PROCEDURE WrShtHex(F: File; V: SHORTCARD; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(VAL(LONGCARD, V),S,16,b);       (* 08-17-01 *)
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrShtHex;


PROCEDURE WrHex(F: File; V: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(VAL(LONGCARD, V),S,16,b);       (* 08-17-01 *)
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrHex;


PROCEDURE WrLngHex(F: File; V: LONGCARD; Length: INTEGER);
VAR S : Str80;
  b : BOOLEAN;
BEGIN
  Str.CardToStr(V,S,16,b);
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrLngHex;


PROCEDURE WrReal(F: File; V: REAL; Precision: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.RealToStr( VAL(LONGREAL, V ),Precision,Eng,S,b);   (* 08-17-01 *)
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrReal;


PROCEDURE WrFixReal(F: File; V: REAL; Precision: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.FixRealToStr( VAL(LONGREAL, V ),Precision,S,b );   (* 08-17-01 *)
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrFixReal;


PROCEDURE WrLngReal(F: File; V : LONGREAL; Precision: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.RealToStr( V,Precision,Eng,S,b);
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrLngReal;


PROCEDURE WrFixLngReal(F: File; V: LONGREAL; Precision: CARDINAL; Length: INTEGER);
VAR
  S : Str80;
  b : BOOLEAN;
BEGIN
  Str.FixRealToStr(V,Precision,S,b );
  IF b THEN
    WrStrAdj(F,S,Length );
  END;
  SetThreadOK(b);
END WrFixLngReal;


PROCEDURE RdBool(F: File): BOOLEAN;
VAR s : Str80;
BEGIN
  RdItem( F,s );
  RETURN Str.Compare( s,TrueStr )=0;
END RdBool;


PROCEDURE RdShtInt(F: File) : SHORTINT;
VAR
  S : Str80;
  i : LONGINT;
  b : BOOLEAN;
BEGIN
  RdItem(F,S );
  i  := Str.StrToInt( S,10,b );
  SetThreadOK( b AND (i >= -80H) AND (i < 80H) );
  RETURN SHORTINT( i );
END RdShtInt;


PROCEDURE RdInt(F: File) : INTEGER;
VAR
  S : Str80;
  i : LONGINT;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  i  := Str.StrToInt( S,10,b );
  SetThreadOK( b AND (i >= -8000H) AND (i < 8000H) );
  RETURN INTEGER(i);
END RdInt;


PROCEDURE RdLngInt(F: File) : LONGINT;
VAR
  S : Str80;
  i : LONGINT;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  i  := Str.StrToInt( S,10,b );
  SetThreadOK(b);
  RETURN i;
END RdLngInt;


PROCEDURE RdShtCard(F: File) : SHORTCARD;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  i  := Str.StrToCard( S,10,b );
  SetThreadOK( b AND (i < 100H) );
  RETURN SHORTCARD( i );
END RdShtCard;


PROCEDURE RdShtHex(F: File) : SHORTCARD;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  i  := Str.StrToCard( S,16,b );
  SetThreadOK( b AND (i < 100H) );
  RETURN SHORTCARD( i );
END RdShtHex;


PROCEDURE RdCard(F: File) : CARDINAL;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  i  := Str.StrToCard( S,10,b );
  SetThreadOK( b AND (i < 10000H) );
  RETURN CARDINAL( i );
END RdCard;


PROCEDURE RdHex(F: File) : CARDINAL;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  i  := Str.StrToCard( S,16,b );
  SetThreadOK( b AND (i < 10000H) );
  RETURN CARDINAL( i );
END RdHex;


PROCEDURE RdLngCard(F: File) : LONGCARD;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  i  := Str.StrToCard( S,10,b );
  SetThreadOK(b);
  RETURN i;
END RdLngCard;


PROCEDURE RdLngHex(F: File) : LONGCARD;
VAR
  S : Str80;
  i : LONGCARD;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  i  := Str.StrToCard( S,16,b );
  SetThreadOK(b);
  RETURN i;
END RdLngHex ;


PROCEDURE RdReal(F: File) : REAL;
VAR
  S   : Str80;
  r   : LONGREAL;
  b : BOOLEAN;
BEGIN
  RdItem(F,S );
  r  := Str.StrToReal( S,b);
  SetThreadOK( b AND (ABS(r) <= 3.4E38) );
  RETURN VAL(REAL, r);                       (* 08-17-01 *)
END RdReal;


PROCEDURE RdLngReal(F: File) : LONGREAL;
VAR
  S : Str80;
  r : LONGREAL;
  b : BOOLEAN;
BEGIN
  RdItem(F,S);
  r  := Str.StrToReal( S,b);
  SetThreadOK(b);
  RETURN r;
END RdLngReal;


PROCEDURE GetName(name: ARRAY OF CHAR);
(* Checks Null terminated filename, also sets IOR to 0 *)
BEGIN
  IF HIGH(name) < Str.Length(name) THEN (* No room for nul *)
    Lib.RunTimeError(00, 0A0H, "File name is truncated!");
  END;
  SetIOR(0);
END GetName;


PROCEDURE Open(Name: ARRAY OF CHAR) : File;
VAR
  tempf: File;
BEGIN
  GetName(Name);
 (*  T__32BIT__ ----
  tempf:= CreateFileA(LPSTR(ADR(Name)),GENERIC_READ+GENERIC_WRITE,
                      VAL(DWORD,ShareMode), LPSECURITY_ATTRIBUTES(NULL),
                      OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 ------*)
 (*  F__32BIT__ *)
 (* tempf:= _lopen(Name,READ_WRITE + INTEGER(ShareMode)); *)
  tempf := OpenFile(Name,OF_STRUCT,VAL(WORD,OF_READWRITE+INTEGER(ShareMode)));  (* 08-23-01 *)
 (*   E*)
  IF tempf = -1 THEN                              (* 08-23-01 *)
    ErrorCheck(2, 0, 'Open : ', Name);
  END;
  RETURN tempf;
END Open;



PROCEDURE OpenRead( Name: ARRAY OF CHAR) : File;
VAR
  tempf: File;
BEGIN
  GetName(Name);
 (*  T__32BIT__ ----
  tempf := CreateFileA(LPSTR(ADR(Name)),GENERIC_READ,
                      VAL(DWORD,ShareMode), LPSECURITY_ATTRIBUTES(NULL),
                      OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 ------*)
 (*  F__32BIT__ *)
 (* tempf := _lopen(Name,READ + INTEGER(ShareMode)); *)
  tempf := OpenFile(Name,OF_STRUCT,VAL(WORD,OF_READ+INTEGER(ShareMode)));   (* 08-23-01 *)
 (*   E*)
  IF tempf = -1 THEN                        (* 08-23-01 *)
    ErrorCheck(3, 0, 'OpenRead : ', Name);
  END;
  RETURN tempf;
END OpenRead;


PROCEDURE OpenWrite( Name: ARRAY OF CHAR) : File;    (* 08-23-01 *)
VAR
  tempf: File;
BEGIN
  GetName(Name);
 (*  T__32BIT__ ----
  tempf := CreateFileA(LPSTR(ADR(Name)),GENERIC_WRITE,
                      VAL(DWORD,ShareMode), LPSECURITY_ATTRIBUTES(NULL),
                      OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 ------*)
 (*  F__32BIT__ *)
 (* tempf := _lopen(Name,READ + INTEGER(ShareMode)); *)
  tempf := OpenFile(Name,OF_STRUCT,VAL(WORD,OF_WRITE+INTEGER(ShareMode)));   (* 08-23-01 *)
 (*   E*)
  IF tempf = -1 THEN                        (* 08-23-01 *)
    ErrorCheck(3, 0, 'OpenWrite : ', Name);
  END;
  RETURN tempf;
END OpenWrite;


PROCEDURE Exists(Name: ARRAY OF CHAR) : BOOLEAN;
VAR
  H: File;
BEGIN
  GetName(Name);
 (*  T__32BIT__ ----
  H := CreateFileA(LPSTR(ADR(Name)),0,
                      VAL(DWORD,OF_SHARE_DENY_NONE), LPSECURITY_ATTRIBUTES(NULL),
                      OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
 ------*)
 (*  F__32BIT__ *)
 (* H := _lopen(Name, OF_READ + OF_SHARE_DENY_NONE); *)
  H := OpenFile(Name,OF_STRUCT,VAL(WORD,OF_EXIST+OF_SHARE_DENY_NONE));     (* 08-23-01 *)
 (*   E*)
  IF H # -1 THEN                        (* 08-23-01 *)
   (* Close( H ); *)                    (* 08-23-01 *)
    RETURN TRUE;
  ELSE
    RETURN FALSE;
  END;
END Exists;


PROCEDURE Append(Name: ARRAY OF CHAR) : File;
VAR
  H: File;
  posn: LONGCARD;
  IOx: SIGNED;
BEGIN
  GetName(Name);
  H := Open(Name);
  IF H = -1 THEN
    SetIOR(-1);
    RETURN H;
  END;
 (*  T__32BIT__ ----
  posn := SetFilePointer(H,0,PLONG(NULL),VAL(DWORD,FILE_END));
  IF posn = 0FFFFFFFFH THEN IOx := -1 ELSE IOx := 0 END;
 ------*)
 (*  F__32BIT__ *)
  posn := _llseek(H,0,FILE_END);
  IOx := 0;
 (*   E*)
  SetIOR(IOx);
  IF IOx # 0 THEN
    ErrorCheck(4, 0, 'Append : ', Name);
  END;
  RETURN H;
END Append;


PROCEDURE Create(Name: ARRAY OF CHAR) : File;
VAR
  tempf: File;
BEGIN
 (*  T__32BIT__ ----
  tempf:= CreateFileA(LPSTR(ADR(Name)),GENERIC_READ+GENERIC_WRITE,
                      FILE_SHARE_READ+FILE_SHARE_WRITE,
                      LPSECURITY_ATTRIBUTES(NULL),
                      CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
 ------*)
 (*  F__32BIT__ *)
 (* tempf:= _lcreat(Name, Normal); *)
  tempf := OpenFile(Name,OF_STRUCT,VAL(WORD,OF_CREATE+INTEGER(ShareMode)));   (* 08-23-01 *)
 (*   E*)
  IF tempf = -1 THEN                              (* 08-23-01 *)
    ErrorCheck(5, 0, 'Create : ', Name);
  END;
  RETURN tempf;
END Create;


PROCEDURE Close(F: File);
VAR
 (*  T__32BIT__ ----
  ok: BOOL;
 ------*)
  IOx: SIGNED;
BEGIN
 (*  T__32BIT__ ----
  ok := CloseHandle(F);
  IF NOT BOOLEAN(ok) THEN IOx := -1 ELSE IOx := 0 END;
 ------*)
 (*  F__32BIT__ *)
  IOx := _lclose(F);
 (*   E*)
  SetIOR(IOx);
  IF IOx # 0 THEN
    ErrorCheck(0, 0, 'Close : ', Lib.NilStr);
  END;
END Close;


PROCEDURE GetPos(F: File) : LONGCARD;
VAR
  posn: LONGCARD;
  IOx: SIGNED;
BEGIN
  SetIOR(0);                                      (* 07-06-01 *)
  SetThreadOK(TRUE);                              (* 07-06-01 *)
 (*  T__32BIT__ ----
  posn:= SetFilePointer(F,0,PLONG(NULL),DWORD(FILE_CURRENT));
  IF posn = 0FFFFFFFFH THEN IOx := -1 ELSE IOx := 0 END;
 ------*)
 (*  F__32BIT__ *)
  posn:= _llseek(F,0,FILE_CURRENT);
  IOx := 0;
 (*   E*)
  SetIOR(IOx);
  IF IOx # 0 THEN
    ErrorCheck(9, 0, 'GetPos : ', Lib.NilStr);
    SetThreadOK(FALSE);                            (* 07-06-01 *)
  END;
  RETURN posn;
END GetPos;


PROCEDURE Seek( F : File; pos:LONGCARD );
VAR
  posn   : LONGCARD;
  IOx: SIGNED;
BEGIN
 (*  T__32BIT__ ----
  posn:= SetFilePointer(F,pos,PLONG(NULL),DWORD(FILE_BEGIN));
  IF posn = 0FFFFFFFFH THEN IOx := -1 ELSE IOx := 0 END;
 ------*)
 (*  F__32BIT__ *)
  posn:= _llseek(F,pos,FILE_BEGIN);
  IF posn <> pos THEN  IOx := -1 ELSE IOx := 0 END;
 (*   E*)
  SetIOR(IOx);
  IF IOx # 0 THEN
    ErrorCheck(0AH, 0, 'Seek : ', Lib.NilStr);
  END;
END Seek;


PROCEDURE Size(F: File) : LONGCARD;
VAR
  Ret: LONGCARD;
  CurPos: LONGCARD;
  IOx: SIGNED;
BEGIN
  CurPos := GetPos(F);
  IF NOT ThreadOK() THEN RETURN 0 END;
 (*  T__32BIT__ ----
  Ret := SetFilePointer(F,0,PLONG(NULL),DWORD(FILE_END));
  IF Ret = 0FFFFFFFFH THEN IOx := -1 ELSE IOx := 0 END;
 ------*)
 (*  F__32BIT__ *)
  Ret := _llseek(F,0,FILE_END);
  IOx := 0;
 (*   E*)
  SetIOR(IOx);
  IF IOx # 0 THEN
    ErrorCheck(0AH, 0, 'Size : ', Lib.NilStr);
  END;
  Seek(F, CurPos);
  RETURN Ret;
END Size;


PROCEDURE Erase(Name:ARRAY OF CHAR);
BEGIN
  GetName(Name);
  IF CWRUN.remove(Name) # 0 THEN
    ErrorCheck(0EH, 0, 'Erase : ', Name);
  END;
END Erase;


PROCEDURE Rename(Name,newname: ARRAY OF CHAR);
BEGIN
  GetName(Name);
  GetName(newname);
  IF CWRUN.rename(Name, newname) # 0 THEN
    ErrorCheck(0FH, 0, 'Rename : ', Name);
  END;
END Rename;


PROCEDURE ReadFirstEntry ( DirName : ARRAY OF CHAR;
                           Attr    : FileAttr;
                           VAR D   : DirEntry) : BOOLEAN;
BEGIN
  Lib.RunTimeError(00, 0A0H, "ReadFirstEntry Not Implemented");
  GetName(DirName);
  IF TRUE THEN
    ErrorCheck(14H, 0, 'ReadFirstEntry : ', DirName);
  END;
  RETURN TRUE;
END ReadFirstEntry;


PROCEDURE ReadNextEntry(VAR D: DirEntry) : BOOLEAN;
BEGIN
  Lib.RunTimeError(00, 0A0H, "ReadNextEntry Not Implemented");
  SetIOR(0);
  IF TRUE THEN
    ErrorCheck(15H, 0, 'ReadNextEntry : ', Lib.NilStr);
  END;
  RETURN TRUE;
END ReadNextEntry;


PROCEDURE ChDir(Name: ARRAY OF CHAR);
BEGIN
  Lib.RunTimeError(00, 0A0H, "ChDir Not Implemented");
  SetIOR(0);
  GetName(Name);
  IF TRUE THEN
    ErrorCheck(10H, 0, 'ChDir : ', Name);
    RETURN;
  END;
  IF (Str.Length(Name) > 1) AND (Name[1] = ':') THEN
    IF SetDrive(SHORTCARD(CAP(Name[0]) - 'A') + 1) = 0 THEN
      ErrorCheck(10H, 0, 'ChDir : ', Name);
    END;
  END;
END ChDir;


PROCEDURE MkDir(Name: ARRAY OF CHAR);
BEGIN
  Lib.RunTimeError(00, 0A0H, "MkDir Not Implemented");
  SetIOR(0);
  GetName(Name);
  IF TRUE THEN
    ErrorCheck(11H, 0, 'MkDir : ', Name);
  END;
END MkDir;


PROCEDURE RmDir(Name: ARRAY OF CHAR);
BEGIN
  Lib.RunTimeError(00, 0A0H, "RmDir Not Implemented");
  SetIOR(0);
  GetName(Name);
  IF TRUE THEN
    ErrorCheck(12H, 0, 'RmDir : ', Name);
  END;
END RmDir;


PROCEDURE GetDir(drive: SHORTCARD; VAR Name: ARRAY OF CHAR);
BEGIN
  Lib.RunTimeError(00, 0A0H, "GetDir Not Implemented");
  SetIOR(0);
  IF TRUE THEN
    ErrorCheck(13H, 0, 'GetDir : ', Lib.NilStr);
  END;
  Str.Concat(Name,'\',Name);
END GetDir;


  PROCEDURE AssignBuffer(F:File;VAR Buf:ARRAY OF BYTE);
    BEGIN
      SetIOR(0);
     (* Not used *)
    END AssignBuffer;


PROCEDURE AppendHandle(F: File; ReadOnly: BOOLEAN);
BEGIN
  Lib.RunTimeError(00, 0A0H, "AppendHandle Not Implemented");
END AppendHandle;


PROCEDURE AppendStream(St: FileInf): File;
VAR F: HANDLE;
BEGIN
  Lib.RunTimeError(00, 0A0H, "AppendStream Not Implemented");
    F := St^.Handle;
    RETURN F;
END AppendStream;


PROCEDURE GetStreamPointer(F: File): FileInf;
VAR St: FileInf;
BEGIN
  Lib.RunTimeError(00, 0A0H, "GetStreamPointer Not Implemented");
  RETURN St;
END GetStreamPointer;


PROCEDURE GetDrive() : SHORTCARD ;
(* Returns the currently selected drive *)
(* A=1,B=2,C=3 etc                      *)
BEGIN
  Lib.RunTimeError(00, 0A0H, "GetDrive Not Implemented");
  SetIOR(0);
  RETURN 0;
END GetDrive ;


PROCEDURE SetDrive(Drive: SHORTCARD): SHORTCARD;
(* Sets the default drive *)
(* A=1,B=2,C=3 etc                      *)
BEGIN
  Lib.RunTimeError(00, 0A0H, "SetDrive Not Implemented");
  SetIOR(0);
  RETURN 0;
END SetDrive ;


PROCEDURE GetCurrentDate () : LONGCARD ;
BEGIN
  RETURN CWRUN.TODAY();
END GetCurrentDate ;


PROCEDURE GetFileDate( f : File) : LONGCARD;
BEGIN
  Lib.RunTimeError(00, 0A0H, "GetFileDate Not Implemented");
  RETURN 0;
END GetFileDate;


PROCEDURE SetFileDate( f : File ; d : LONGCARD ) ;
BEGIN
  Lib.RunTimeError(00, 0A0H, "SetFileDate Not Implemented");
END SetFileDate;


PROCEDURE ThreadEOF(): BOOLEAN;
BEGIN
  RETURN EOFTable[VAL(CARDINAL, CWRUN.THREAD())];    (* 08-17-01 *)
END ThreadEOF;


PROCEDURE ThreadOK(): BOOLEAN;
BEGIN
  RETURN OKTable[VAL(CARDINAL, CWRUN.THREAD())];     (* 08-17-01 *)
END ThreadOK;


PROCEDURE GetFileStamp(f : File ; VAR b: FileStamp) : BOOLEAN;
VAR
    DT : RECORD
          CASE : BOOLEAN OF
            TRUE  :  ft,fd : CARDINAL; |
            FALSE :  l     : LONGCARD;
          END;
        END;
BEGIN
  DT.l := GetFileDate(f);
  IF DT.l = MAX(LONGCARD) THEN
    RETURN FALSE;
  ELSE
    b.Year  := SHORTCARD(DT.fd>>9+80) ;
    b.Month := SHORTCARD((DT.fd>>5) MOD 16) ;
    b.Day   := SHORTCARD(DT.fd MOD 32) ;
    b.Hour  := SHORTCARD(DT.ft>>11) ;
    b.Min   := SHORTCARD((DT.ft>>5) MOD 64) ;
    b.Sec   := SHORTCARD(DT.ft MOD 32) ;
    RETURN TRUE;
  END;
END GetFileStamp;




BEGIN
  Lib.Fill(ADR(IOR),SIZE(IOR),0C);
  Lib.Fill(ADR(OKTable),SIZE(OKTable),0C);
  Lib.Fill(ADR(EOFTable),SIZE(EOFTable),0C);
  Eng     := FALSE;
  IOcheck := TRUE;
  OK      := TRUE;
  ChopOff := FALSE;
  EOF     := FALSE;
  EOL     := CHR (10);
  PrefixChar    := ' ';
  SuffixChar    := ' ';
  ShareMode := ShareCompat;
  Separators := Str.CHARSET{CHR(9),CHR(10),CHR(13),CHR(26),' '};
END FIO.
